import _ from "lodash";

export default {
  state: {
    awaitables: [],
    message: "",
    messageTimeout: null,

  },
  getters: {
    getCurrentAwaitables(state) {
      return state.awaitables;
    },

    isAwaiting(state) {
      return state.getCurrentAwaitables.length > 0;
    },

    getMessage(state) {
      return state.message;
    }
  },
  mutations: {
    addAwaitable(state, awaitable) {
      state.awaitables.push(awaitable);
    },
    removeAwaitable(state, awaitable) {
      state.awaitables = state.awaitables.filter((a) => a.id != awaitable.id)
    },
    setErrorMessage(state, message) {
      window.clearTimeout(state.messageTimeout)
      state.messageTimeout = window.setTimeout(() => { state.message = null }, 8000)
      state.message = message;
    },


  },
  actions: {
    addAwaitable(context, awaitable) {
      context.commit('addAwaitable', awaitable);
      awaitable.promise.finally(function () {
        context.commit('removeAwaitable', awaitable);
      })
    },
    setErrorMessage(context, errorMessage) {
      debugger;

      if (errorMessage.error.ignoreUnhandledRejection) {
        return
      }
      context.commit('setErrorMessage', `${errorMessage.error.response?.data?.error} - ${errorMessage.error.response?.data?.message}`);
      throw { source: errorMessage.error, ignoreUnhandledRejection: true };
    },
  }
}